#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <gtk/gtk.h>
#include <gdk/gdkx.h>
#include <sys/types.h>
#include <sys/wait.h>

#define IS_OUTFH    101
#define IS_ERRFH    102


int pin[2],pot[2],per[2];
int start,tlim = 0;
char xids[16], fil[512];
  GtkWidget *mpla_socket;

int  myfork(int myin,int myot,int myer,char *xids)
{
  int child;

  child = fork();
  if (child == -1)
    exit(1);
  if (!child) {
    /* se il figlio */
    close(0);
    close(1);
    close(2);
    dup2(myin,0);
    dup2(myot,1);
    dup2(myer,2);
    
    execl("/usr/local/bin/mplayer", "", "-wid", xids, "-slave", fil, NULL);
    exit(0);
  }
  return 1;
}


void mysmazz( gpointer          data,
	      gint              source, 
	      GdkInputCondition condition )
{
  static char lb[512];
  static int c = 0;

  char bf[512], *p;
  int n, v[2], i, a, st;

  n = read(source,bf,512);
  
  if ((int)data == IS_ERRFH) {
    for (a = 0 ; a < n ; a++) {
      if (bf[a] != '\r' && bf[a] != '\n' && a < 512) {
	lb[c++] = bf[a];
	continue;
      }
      if (!memcmp(lb,"VIDEO:",6)) {
	st = 0;
	for (i = 0 ; i < c ; i++) {
	  switch(st) {
	  case 0:
	  case 2:
	    if (lb[i] == ' ')
	      st++;
	    break;
	  case 1:
	  case 3:
	    if (lb[i] != ' ') {
	    p = &(lb[i]);
	    st++;
	    }
	    break;
	  case 4:
	  case 6:
	    if (lb[i] == 'x' || lb[i] == ' ') {
	      lb[i] = '\0';
	      v[(st-4)>>1] = atoi(p);
	      st++;
	    }
	    break;
	  case 5:
	    p = &(lb[i]);
	    st++;
	    break;
	  case 7:
	    i = 512;
	    break;
	  }
	}
	// fprintf(stderr,"X %d Y %d",v[0],v[1]);
	if (st == 7)
	  gtk_widget_set_size_request(mpla_socket,v[0],v[1]);
	// gtk_widget_set_size_request(mpla_socket,400,300);
      }
      c = 0;
    }
  }

}

gint mytimer(gpointer data)
{
  static int ct = 0,ret,pid;

  if (ct == 40)
    write(pin[1],"pause\n",6);

  if (ct == 140)
    write(pin[1],"pause\n",6);
  ct++;

  if ((pid = waitpid(0,&ret,WNOHANG)) > 0) {
    ;
    // myfork(pin[0],pot[1],per[1],xids);
  }

  return TRUE;
}

int main(int argc,char *argv[])
{
  GtkWidget *main_window;
  guint32 xid;

  gtk_init (&argc, &argv);

  if (argc != 2) {
    fprintf(stderr,"Usage:\n  %s filename\n\n",argv[0]);
    exit(1);
  }
  strcpy(fil,argv[1]);

  main_window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
  mpla_socket = gtk_socket_new();
  gtk_container_add(GTK_CONTAINER(main_window), mpla_socket);
  gtk_widget_realize(mpla_socket);
  xid = gtk_socket_get_id((GtkSocket *)mpla_socket);
  gtk_widget_set_size_request(mpla_socket,100,100);
  gtk_widget_show(mpla_socket);
  gtk_widget_show(main_window);

  gtk_timeout_add(50,mytimer,"");
  pipe(pin);
  pipe(pot);
  pipe(per);
  tlim = (pot[0] > per[0] ? pot[0] : per[0]) + 1;
  sprintf(xids,"%d",xid);

  myfork(pin[0],pot[1],per[1],xids);

  gdk_input_add(pot[0],GDK_INPUT_READ,mysmazz,(gpointer)IS_OUTFH);
  gdk_input_add(per[0],GDK_INPUT_READ,mysmazz,(gpointer)IS_ERRFH);

  gtk_main();
  
  exit(0);
  return(1);
}
